#include <WinControlSetEvent.au3>

;============== Calc Demo ==============
;In this example we use the main loop to avoid blocking of mouse processing from inside CalcGetResult_Proc() function.

HotKeySet("^q", "_Quit")

$iGetCalcResults = False

Run("Calc.exe")

For $i = 1 To 9
	_WinControlSetEvent("[CLASS:SciCalc]", $i, "", "", "CalcGetResult_Proc", "'" & $i & "' Button has been pressed")
Next

_WinControlSetEvent("[CLASS:SciCalc]", "=", "", "", "CalcGetResult_Proc", "'=' Button has been pressed")
_WinControlSetEvent("[CLASS:SciCalc]", "/", "", "", "CalcGetResult_Proc", "'/' Button has been pressed")
_WinControlSetEvent("[CLASS:SciCalc]", "*", "", "", "CalcGetResult_Proc", "'*' Button has been pressed")
_WinControlSetEvent("[CLASS:SciCalc]", "-", "", "", "CalcGetResult_Proc", "'-' Button has been pressed")
_WinControlSetEvent("[CLASS:SciCalc]", "+", "", "", "CalcGetResult_Proc", "'+' Button has been pressed")

_WinControlSetEvent("[CLASS:SciCalc]", "Button28", "", "", "CalcGetResult_Proc", "'X' Button has been pressed")

While 1
	Sleep(10)
	
	If $iGetCalcResults <> False Then
		$iParam = $iGetCalcResults
		$iGetCalcResults = False
		
		If $iParam = 168 Then Exit ;Calc closed
		
		$sCtrl_Data = ControlGetText("[CLASS:SciCalc]", "", $iParam)
		
		If $sCtrl_Data = "=" Then
			Local $sResult = StringStripWS(ControlGetText("[CLASS:SciCalc]", "", "Edit1"), 3)
			If StringRight($sResult, 1) = "," Then $sResult = StringTrimRight($sResult, 1)
		
			ToolTip("The result has been calculated: " & $sResult, Default, Default, "Calc Info", 1, 5)
		ElseIf $sCtrl_Data <> "" Then
			ToolTip("Calc Button Pressed: " & $sCtrl_Data, Default, Default, "Calc Info", 1, 5)
		EndIf
	EndIf
WEnd

;Warning: blocking of this function by window messages with commands such as "Msgbox()" can lead to unexpected behavior,
;the return to the system should be as fast as possible !!!
Func CalcGetResult_Proc($sParams, $hWnd, $nCtrlID)
	ConsoleWrite("Passed params: " & $sParams & @CRLF)
	
	$iGetCalcResults = $nCtrlID
EndFunc

Func _Quit()
	Exit
EndFunc
